//============================================================================
//  t@C
//----------------------------------------------------------------------------
//													Programmed by 
//============================================================================
#include "stdafx.h"
#include <string.h>
#include <memory.h>
#include "generic.h"
#include "path.h"

#define IsKanji(c) ( (unsigned char)((int)((unsigned char)(c) ^ 0x20) - 0x0A1) < 0x3C )

//============================================================================
//  RXgN^
//============================================================================
cPath::cPath()
{
#if FILEMANAGER_PATH_MAX == 0
	Drive = 0;
	Dir = 0;
	Name = 0;
	ExtName = 0;
	Path = 0;
#else
	memset( Drive, 0, FILEMANAGER_PATH_MAX );
	memset( Dir, 0, FILEMANAGER_PATH_MAX );
	memset( Name, 0, FILEMANAGER_PATH_MAX );
	memset( ExtName, 0, FILEMANAGER_PATH_MAX );
	memset( Path, 0, FILEMANAGER_PATH_MAX );
#endif
	Dummy = 0;
}

//============================================================================
//  fXgN^
//============================================================================
cPath::~cPath()
{
	Release();
}

//============================================================================
//  pXJ
//----------------------------------------------------------------------------
// In  : drive = hCu
//============================================================================
void cPath::Release( void )
{
#if PATH_STRING_MAX == 0
	if ( Drive != 0 )
	{
		free( Drive );
		Drive = 0;
	}
	if ( Dir != 0 )
	{
		free( Dir );
		Dir = 0;
	}
	if ( Name != 0 )
	{
		free( Name );
		Name = 0;
	}
	if ( ExtName != 0 )
	{
		free( ExtName );
		ExtName = 0;
	}
	if ( Path != 0 )
	{
		free( Path );
		Path = 0;
	}
#else
	memset( Drive, 0, FILEMANAGER_PATH_MAX );
	memset( Dir, 0, FILEMANAGER_PATH_MAX );
	memset( Name, 0, FILEMANAGER_PATH_MAX );
	memset( ExtName, 0, FILEMANAGER_PATH_MAX );
	memset( Path, 0, FILEMANAGER_PATH_MAX );
#endif
}

//============================================================================
//  hCuݒ
//----------------------------------------------------------------------------
// In  : drive = hCu
//============================================================================
void cPath::SetDrive( char *drive )
{
	Drive = StrCopy( Drive, drive );
	MakePath();
}

//============================================================================
//  fBNgݒ
//----------------------------------------------------------------------------
// In  : dir = fBNgpX
//============================================================================
void cPath::SetDir( char *dir )
{
	Dir = StrCopy( Dir, dir );
	MakePath();
}

//============================================================================
//  t@Cl[ݒ
//----------------------------------------------------------------------------
// In  : name = t@Cl[
//============================================================================
void cPath::SetName( char *name )
{
	Name = StrCopy( Name, name );
	MakePath();
}

//============================================================================
//  gqݒ
//----------------------------------------------------------------------------
// In  : extname = gq
//============================================================================
void cPath::SetExtName( char *extname )
{
	ExtName = StrCopy( ExtName, extname );
	MakePath();
}

//============================================================================
//  pXݒ
//----------------------------------------------------------------------------
// In  : path = pX
//============================================================================
void cPath::SetPath( char *path )
{
	Release();
	Path = StrCopy( Path, path );
	DividePath();
}

//============================================================================
//  pX擾
//----------------------------------------------------------------------------
// Out  : pXւ̃|C^
//============================================================================
char* cPath::GetPath( unsigned int mode )
{
	MakePath( mode );
	return Path;
}

//============================================================================
//  hCu擾
//----------------------------------------------------------------------------
// Out  : hCuւ̃|C^
//============================================================================
char* cPath::GetDrive( void )
{
	if ( Drive )
	{
		return Drive;
	}
	return &Dummy;
}

//============================================================================
//  fBNg擾
//----------------------------------------------------------------------------
// Out  : fBNgւ̃|C^
//============================================================================
char* cPath::GetDir( void )
{
	if ( Dir )
	{
		return Dir;
	}
	return &Dummy;
}

//============================================================================
//  t@C擾
//----------------------------------------------------------------------------
// Out  : t@Cւ̃|C^
//============================================================================
char* cPath::GetName( void )
{
	if ( Name )
	{
		return Name;
	}
	return &Dummy;
}

//============================================================================
//  gq擾
//----------------------------------------------------------------------------
// Out  : pXւ̃|C^
//============================================================================
char* cPath::GetExtName( void )
{
	if ( ExtName )
	{
		return ExtName;
	}
	return &Dummy;
}

//============================================================================
//  fBNgAt@Cl[Agqɕ
//============================================================================
int cPath::DividePath( void )
{
	if ( 0 == Path )
	{
		return 1;
	}
	if ( '\0' == *Path )
	{
		return 1;
	}
	int start = 0;
	int i = 0;
	int driveflag = 0;
	int nameflag = 0;
	bool kanji = false;
	while( 1 )
	{
		if ( IsKanji( Path[ i ] ) )
		{
			//  1 oCg
			i ++;
			kanji = true;
			continue;
		}
		if( ':' == Path[ i ] )
		{
			// hCu
			if ( ( 0 == i ) || ( 1 == driveflag ) )
			{
				// 0 ځApX̓rɁu:v͖
				return 1;
			}
			Drive = StrCopyPart( Drive, Path, start, i );
			start = i + 1;
			driveflag = 1;
		}
		if( ( '\\' == Path[ i ] ) || ( '/' == Path[ i ] ) )
		{
			if( kanji )
			{
				i ++;
				kanji = false;
				continue;
			}
			// fBNg
			Dir = StrAddPart( Dir, Path, start, i );
			start = i + 1;
		}
		if( '.' == Path[ i ] )
		{
			// t@C
			if ( 1 == nameflag )
			{
				Name = StrAdd( Name, "." );
			}
			Name = StrAddPart( Name, Path, start, i - 1 );
			start = i + 1;
			nameflag = 1;
		}
		if( '\0' == Path[ i ] )
		{
			// t@C܂͊gq
			if ( 1 == nameflag )
			{
				// gq
				ExtName = StrAddPart( ExtName, Path, start, i - 1 );
			}
			else
			{
				// t@C
				Name = StrAddPart( Name, Path, start, i - 1 );
			}
			break;
		}
		kanji = false;
		i ++;
	}
	return 0;
}

//============================================================================
//  pX쐬
//============================================================================
void cPath::MakePath( unsigned int mode )
{
	if ( ( mode & PATH_MODE_DRIVE ) && ( Drive != 0 ) )
	{
		Path = StrCopy( Path, Drive );
	} else {
		Path = StrCopy( Path, "" );
	}
	if ( ( mode & PATH_MODE_DIR ) && ( Dir != 0 ) )
	{
		Path = StrAdd( Path, Dir );
		if ( strlen( Path ) > 0 )
		{
			char dividechar[ 2 ];
			dividechar[ 0 ] = PATH_DIVIDE_CHAR;
			dividechar[ 1 ] = '\0';
			if ( Path[ strlen( Path ) -1 ] != PATH_DIVIDE_CHAR )
			{
				Path = StrAdd( Path, dividechar );
			}
		}
	}
	if ( ( mode & PATH_MODE_NAME ) && ( Name != 0 ) )
	{
		Path = StrAdd( Path, Name );
	}
	if ( ( mode & PATH_MODE_EXTNAME ) && ( ExtName != 0 ) )
	{
		if ( *ExtName != '\0' )
		{
			Path = StrAdd( Path, "." );
			Path = StrAdd( Path, ExtName );
		}
	}
}

//============================================================================
//  Rs[
//----------------------------------------------------------------------------
// In  : dest = Rs[
//     : source = Rs[
// Out : dest ̃|C^
//============================================================================
char* cPath::StrCopy( char *dest, char *source )
{
#if PATH_STRING_MAX == 0
	if ( dest != 0 )
	{
		free( dest );
	}
	dest = (char*)malloc( strlen( source ) + 1 );
#endif
	strcpy( dest, source );
	return dest;
}

//============================================================================
//  ̕Rs[
//----------------------------------------------------------------------------
// In  : dest = Rs[
//     : source = Rs[
//     : sourcestart = Rs[̍ŏ̈ʒu
//     : sourceend = Rs[̍Ō̈ʒu
// Out : dest ̃|C^
//============================================================================
char* cPath::StrCopyPart( char *dest, char *source, int sourcestart, int sourceend )
{
#if PATH_STRING_MAX == 0
	if ( dest != 0 )
	{
		free( dest );
	}
	dest = (char*)malloc( sourceend - sourcestart + 2 );
#endif
	int sourceindex;
	int destindex = 0;
	for ( sourceindex = sourcestart; sourceindex <= sourceend; sourceindex ++ )
	{
		dest[ destindex ] = source[ sourceindex ];
		destindex ++;
	}
	dest[ destindex ] = '\0';
	return dest;
}

//============================================================================
//  ǉ
//----------------------------------------------------------------------------
// In  : dest = Rs[
//     : source = Rs[
// Out : dest ̃|C^
//============================================================================
char* cPath::StrAdd( char *dest, char *source )
{
#if PATH_STRING_MAX == 0
	if ( dest != 0 )
	{
		char *temp;
		int size;
		size = strlen( dest );
		temp = (char*)malloc( size + 1 );
		strcpy( temp, dest );
		free( dest );
		dest = (char*)malloc( size + strlen( source ) + 1 );
		strcpy( dest, temp );
		free( temp );
	}
	else
	{
		dest = (char*)malloc( strlen( source ) + 1 );
		memset( dest, 0, strlen( source ) + 1 );
	}
#endif
	strcat( dest, source );
	return dest;
}

//============================================================================
//  ̕ǉ
//----------------------------------------------------------------------------
// In  : dest = Rs[
//     : source = Rs[
//     : sourcestart = Rs[̍ŏ̈ʒu
//     : sourceend = Rs[̍Ō̈ʒu
// Out : dest ̃|C^
//============================================================================
char* cPath::StrAddPart( char *dest, char *source, int sourcestart, int sourceend )
{
#if PATH_STRING_MAX == 0
	if ( dest != 0 )
	{
		char *temp;
		int size;
		size = strlen( dest );
		temp = (char*)malloc( size + 1 );
		strcpy( temp, dest );
		free( dest );
		dest = (char*)malloc( size + strlen( source ) + 1 );
		strcpy( dest, temp );
		free( temp );
	}
	else
	{
		dest = (char*)malloc( sourceend - sourcestart + 2 );
		memset( dest, 0, sourceend - sourcestart + 2 );
	}
#endif
	int sourceindex;
	int destindex;
	destindex = strlen( dest );
	for ( sourceindex = sourcestart; sourceindex <= sourceend; sourceindex ++ )
	{
		dest[ destindex ] = source[ sourceindex ];
		destindex ++;
	}
	dest[ destindex ] = '\0';
	return dest;
}
